import pygame, random
import mmRope, mmPlayer, mmEnemy, mmFragment, mmCheckpoint, mmScene

img_bg = None
img_player = []
img_shake = range(13)

screen = None
SCREEN_WIDTH = 800
SCREEN_HEIGHT = 600

font = None 

def load_image(filename, colorkey = False):
    image = pygame.image.load(filename)
    image.convert()
    if colorkey:
        image.set_colorkey((255,255,0), pygame.RLEACCEL)
    return image

def init_pygame():
    global screen
    pygame.init()
    pygame.font.init()
    screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT), 0, 32)
    
def load_im_num(str_start, str_end, num_start, num_end):
    list = []
    i = num_start
    for i in range(num_end):
        list.append(load_image(str_start + str(i) + str_end))
    return list

def blit_text(text, pos, col):
    i = font.render(text, 1, col)
    r = i.get_rect(centerx = pos[0], centery = pos[1])
    r.w = i.get_width()
    r.h = i.get_height()    
    screen.blit(img_bg, r, r)
    screen.blit(i, r)
    
def blit_text2(text, pos, col):
    i = font.render(text, 1, col)
    r = i.get_rect(centerx = pos[0], centery = pos[1])
    
    screen.blit(i, r)
    

    
    
def load_files():
    global img_bg, img_shake, img_player, img_enemys, img_flags, font
    img_bg = load_image("data/nbg.jpeg")
    img_player = load_im_num("data/mime/mime", ".png", 0, 8)
    img_shake = load_im_num("data/shake/shake", ".png", 0, 13)
    
    mmCheckpoint.img_flags = load_im_num("data/flags/flag", ".png", 0, 5)
    
        
    walker = []
    stand_frames = load_im_num("data/enemys/ropewalker/stand/stand", ".png", 0, 1)
    move_frames = load_im_num("data/enemys/ropewalker/move/move", ".png", 0, 2)
    swing_frames = load_im_num("data/enemys/ropewalker/swing/swing", ".png", 0, 1)
    shake_frames = load_im_num("data/enemys/ropewalker/shake/shake", ".png", 0, 1)
    walker.append(stand_frames)
    walker.append(move_frames)
    walker.append(swing_frames)
    walker.append(shake_frames)
   
    mmEnemy.img_enemys.append(walker)
    
    hanger = []
    stand_frames = load_im_num("data/enemys/hanger/stand/stand", ".png", 0, 1)
    move_frames = load_im_num("data/enemys/hanger/move/move", ".png", 0, 2)
    swing_frames = load_im_num("data/enemys/hanger/attack/attack", ".png", 0, 4)
    shake_frames = load_im_num("data/enemys/hanger/shake/shake", ".png", 0, 1)
    hanger.append(stand_frames)
    hanger.append(move_frames)
    hanger.append(swing_frames)
    hanger.append(shake_frames)
    hanger.append(shake_frames)
    mmEnemy.img_enemys.append(hanger)
    
    font = pygame.font.Font(None, 36)
    
def menu():
    img_play = load_image("data/play.png")
    img_quit = load_image("data/quit.png")
    img_bg = load_image("data/menubg.png")
    x = 400-32
    y = 300-64
    screen.blit(img_bg,(0,0))
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 1
                if event.key == pygame.K_ENTER:
                    pass
                            
        screen.blit(img_play, (x,y))
        screen.blit(img_quit, (x,70+y))
        
        if pygame.mouse.get_pressed()[0] == True:
            mx, my = pygame.mouse.get_pos()
            if mx > x and mx < x + 128 and my > y and my < y + 64:
                return 2
            if mx > x and mx < x + 128 and my > y+70 and my < y + 64 + 70:
                return 1
       
        
                
        pygame.display.flip()
        
def cont():
    img_cont = load_image("data/cont.png")
    img_quit = load_image("data/quit.png")
    x = 400-32
    y = 300-64
    pygame.draw.rect(screen, (0,0,0), (0,0, 800,600))
    screen.blit(img_cont, (x,y))
    screen.blit(img_quit, (x,70+y))
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 1
        
        if pygame.mouse.get_pressed()[0] == True:
            mx, my = pygame.mouse.get_pos()
            if mx > x and mx < x + 128 and my > y and my < y + 64:
                return 2
            if mx > x and mx < x + 128 and my > y+70 and my < y + 64 + 70:
                return 1
       
        
                
        pygame.display.flip()


        
def next_level():
    blit_text("Level Complete! Press Space to continue", (400,300), (255,255,255))
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 1
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 1
                if event.key == pygame.K_SPACE:
                    return 0
                
        
        pygame.display.flip()
        
def game(level):
    player = mmPlayer.Player(img_player, (400,300))
    tight_rope = mmRope.TightRope(SCREEN_WIDTH, SCREEN_HEIGHT, img_shake)

    screen.blit(img_bg, (0,0))
    
    scene = mmScene.Scene(level)
    
    over = False
    
    dietime = 0

    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 0
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 0

        #pre draw
        screen.blit(img_bg, (0,430-50), (0,430-50,800,100))
        screen.blit(img_bg, player.predraw(), player.predraw())
        for i in mmEnemy.enemys:
            screen.blit(img_bg, i.predraw(), i.predraw())
        for i in mmCheckpoint.flags:
            screen.blit(img_bg, i.predraw(), i.predraw())
        for i in range(len(mmFragment.fraglist)):
            screen.blit(img_bg, mmFragment.fraglist[i].predraw(), mmFragment.fraglist[i].predraw())
            
        
        
        #update
        s = player.update(pygame.mouse.get_pos()[0], tight_rope.srange)
        if s:
            tight_rope.start_shake()
        if player.rect.y > 430:
            tight_rope.set_point(player.rect.x,player.rect.y)
        else:
            tight_rope.set_point(1,430)
        if over:
            tight_rope.set_point(1,430)
        tight_rope.update()
        for i in range(len(mmEnemy.enemys)):
            if i >= len(mmEnemy.enemys):
                    break
            d = mmEnemy.enemys[i].update(tight_rope.point,tight_rope.poses, (player.rect.x, player.rect.y), tight_rope.shaking)
            if d == 1:
                scene.onEnemyDie(mmEnemy.enemys[i].id)
                del mmEnemy.enemys[i]
            elif d == 2:
                #the boss uses this
                tight_rope.start_shake()
            elif d == 0:
                if mmEnemy.enemys[i].isAttacking and not over:
                    a = mmEnemy.enemys[i].getAttack()
                    if (a[2] == 1 and player.rect.x < a[0]) or (a[2] == 0 and player.rect.x > a[0]):
                        if abs(player.rect.x-a[0]) < a[1]:
                            over = True
                            player.die()
                            dietime = pygame.time.get_ticks()
                                                    
        for i in range(len(mmFragment.fraglist)):
            if i >= len(mmFragment.fraglist):
                    break
            d = mmFragment.fraglist[i].update()
            if d:
                del mmFragment.fraglist[i]

            
        for i in range(len(mmCheckpoint.flags)):
            if i >= len(mmCheckpoint.flags):
                    break
            d = mmCheckpoint.flags[i].update((player.rect.x,player.rect.y))
            if d:
                scene.onFlag(mmCheckpoint.flags[i].id,mmCheckpoint.flags[i].num)
                del mmCheckpoint.flags[i]
            
                
                
        scene.update(tight_rope.shaking, (player.rect.x,player.rect.y), over)
        if scene.end:
            return 3
        
        if over and pygame.time.get_ticks()-dietime > 5000:
            return 2
                
        #tight_rope.set_point(400,300)
        if not over:
            pygame.mouse.set_pos(SCREEN_WIDTH/2, SCREEN_HEIGHT/2)
        #draw
        screen.blit(img_bg, (350,0), (350,0,100,50))
        screen.blit(img_bg, (0,560), (0,560,800,600-560))
        blit_text(str(scene.score), (400,38), (255,255,255))
        blit_text(scene.voice, (400,580), (255,255,255))
        tight_rope.draw()
        for i in mmEnemy.enemys:
            i.draw()
        for i in mmCheckpoint.flags:
            i.draw()
        player.show()   
        for i in range(len(mmFragment.fraglist)):
            mmFragment.fraglist[i].draw()
        pygame.display.flip()
        
                
def win():
    pygame.draw.rect(screen, (0,0,0), (0,0, 800,600))
    blit_text2("CONGRATS! YOU WIN!!!", (400,300), (255,255,255))
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return 2
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    return 2
                if event.key == pygame.K_SPACE:
                    return 1
        
        
        pygame.display.flip()

def main():
    init_pygame()
    load_files()
    
    c = 0
    over = False
    
    level_list = ("data/scenes/level01.scn","data/scenes/level02.scn","data/scenes/level03.scn","data/scenes/level04.scn")
    
    #menu 0
    #continue? 1
    #next level 2
    #quit 3
    
    level = 0
    
    while not over:
        mmEnemy.enemys = []
        mmFragment.fraglist = []
        mmCheckpoint.flags = []        
        if c == 0:
            r = menu()    
            if r == 1:
                break
        pygame.mouse.set_visible(False)
        r = game(level_list[level])
        pygame.mouse.set_visible(True)
        if r == 0:
            over = True
        if r == 1:
            pass
        if r == 2:
            s = cont()
            if s == 1:
                c = 0
            if s == 2:
                c = 1
            continue                
        if r == 3:
            s = next_level()
            if s == 1:
                return
            c = 2
            level += 1
        if c == 2 and level >= len(level_list):
            s = win()
            if s == 1:
                c = 0
            if s == 2:
                return
            
            

    

        
        


