import pygame, random, math

fraglist = []

class Fragment:
	def __init__(self, image, pos, vel, srot = 0, add_rot = 0, vel_add = []):
		self.vel = [vel[0], vel[1]]
		self.rot = srot
		self.rvel = add_rot
		self.vel_add = vel_add
		self.image = image
		self.rect = self.image.get_rect()
		self.rimage = self.image
		self.last_time = pygame.time.get_ticks()
		self.rect.x, self.rect.y = pos
	def update(self):
		delta = pygame.time.get_ticks() - self.last_time
		self.rect.x += self.vel[0] * delta
		self.rect.y += self.vel[1] * delta
		

		self.vel[0] += self.vel_add[0]*delta
		self.vel[1] += self.vel_add[1]*delta
		
		self.rot+=self.rvel*delta
		
		self.last_time = pygame.time.get_ticks()
		
		if (self.rect.y > 600) or (self.rect.y+self.rect.h < 0) or (self.rect.x > 800) or (self.rect.x+self.rect.w < 0):
			return 1
		return 0
		
	def draw(self):
		#self.rimage = pygame.transform.rotozoom(self.image, self.rot, 1)
		self.rimage = pygame.transform.rotate(self.image, self.rot)
		pygame.display.get_surface().blit(self.rimage, self.rect)
	def predraw(self):
		r = self.rimage.get_rect()
		r.x, r.y = self.rect.x, self.rect.y
		return r