import pygame, random, mmFragment

class Player:
    def __init__(self, img, start_pos):
        self.image = img
        self.rect = self.image[0].get_rect()
        self.rect.x = start_pos[0]
        self.rect.y = start_pos[1]
        self.rate = 0.8
        self.last_time = pygame.time.get_ticks()
        self.tilt = 0.0
        self.max_tilt = 0.5
        self.jump_vel = 0
        self.vert = 0.0
        self.jumping = True
        self.rimage = self.image[0]
        self.dead = False
        self.frame = 0.0
        
    def update(self, mx, shake):
        delta = float(pygame.time.get_ticks() - self.last_time)
        keystate = pygame.key.get_pressed()
        
        
        degree = mx-400
        if degree > 64:
            degree = 64
        if degree < -64:
            degree = -64
            
        
            
        degree = 1.0 * (float(degree)/64.0)
        self.tilt += degree*self.rate
        if self.tilt > self.max_tilt: self.tilt = self.max_tilt
        if self.tilt < -self.max_tilt: self.tilt = -self.max_tilt
             
        self.rect.x += self.tilt*delta
        if self.rect.x < 0:
            self.rect.x = 0
        if self.rect.x > 800 and not self.dead:
            self.rect.x = 800
        
        #jumping
        
        rshake = False
        if keystate[pygame.K_SPACE] and not self.jumping and not self.dead:
            self.jump()
            rshake = True
        
        if self.jumping:      
            self.vert -= 0.005 * delta
            self.rect.y -= self.vert * delta
            
        if self.rect.y > 430+20:
            self.rect.y = 430+20
            if self.vert < 0:
                self.jumping = False
                
        #animation
        self.frame -= self.tilt * 0.05 * delta
        if self.frame >= len(self.image):
            self.frame = 0
        if self.frame < 0:
            self.frame = len(self.image)-1
        
        
        self.last_time = pygame.time.get_ticks()
        
        return rshake
        
    def jump(self):
        self.vert = 1.5   
        self.jumping = True     
        
    def predraw(self):
        r = self.rimage.get_rect()
        r.x = self.rect.x
        r.y = self.rect.y
        t = 0
        if(self.tilt < 0):
            t = self.tilt * 70
        return (r.x-(r.w/2), r.y-r.h, r.w, r.h+20)
            
    def show(self):
        #self.rimage = pygame.transform.rotozoom(self.image[int(self.frame)], -self.tilt * 45, 1)
        self.rimage = pygame.transform.rotate(self.image[int(self.frame)], -self.tilt * 45)
        t = 0
        if(self.tilt < 0):
            t = self.tilt * 70
        if self.dead != True:
            pygame.display.get_surface().blit(self.rimage, (self.rect.x-(self.rect.w/2) + t, self.rect.y-self.rect.h - abs(self.tilt)*30))
    def die(self):
        mmFragment.fraglist.append(mmFragment.Fragment(self.image[int(self.frame)], (self.rect.x-(self.rect.w/2),self.rect.y-self.rect.h), (0,-0.5), 0,0, (0,0.005)))
        self.dead = True
        self.rect.x = 10000